ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.14 by root, Wed Mar 14 00:04:59 2007 UTC vs.
Revision 1.86 by root, Tue Oct 5 22:33:10 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
80 or die "map installation failed.\n"; 156 and die "map installation failed.\n";
81 157
82 print "maps installed successfully.\n"; 158 print "maps installed successfully.\n";
83} 159}
84 160
85{ 161{
86 our %PNG32; 162 our %ANIMINFO;
87 our %FACEINFO; 163 our %FACEINFO;
164 our %RESOURCE;
88 our @ARC; 165 our @ARC;
166 our %ARC;
89 our $TRS; 167 our $TRS;
90 our $NFILE; 168 our $NFILE;
91 our %ANIM; 169 our $PATH;
92 170
93 our (@png, @trs, @arc); # files we are interested in 171 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
94 172
173 our $c_arc = new Coro::Channel;
174 our $c_trs = new Coro::Channel;
175 our $c_res = new Coro::Channel;
176
177 our @c_png;
178
95 sub commit_png { 179 sub commit_png($$$$) {
96 my ($name, $data) = @_; 180 my ($stem, $name, $data, $T) = @_;
97 181
98 $PNG32{$name} = $data; 182 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
99 $FACEINFO{$name} ||= {}; 183 $FACEINFO{$name}{"data$T"} = $data;
100 } 184 }
101 185
102 sub process_png { 186 sub process_png {
103 while (@png) { 187 while (@c_png) {
104 my $path = pop @png; 188 my ($path, $delete) = @{pop @c_png};
105 189
106 my $png; 190 my $png;
107 aio_lstat $path; 191 aio_lstat $path;
108 my ($size, $mtime) = (stat _)[7,9]; 192 my ($size, $mtime) = (stat _)[7,9];
109 193
110 if (0 > aio_load $path, $png) { 194 if (0 > aio_load $path, $png) {
111 warn "$path: $!, skipping.\n"; 195 warn "$path: $!, skipping.\n";
112 next; 196 next;
113 } 197 }
114 198
199 my $stem = $path;
200 my $T;
201
202 if ($stem =~ s/\.32x32\.png~?$//) {
203 $T = 32;
204 } elsif ($stem =~ s/\.64x64\.png~?$//) {
205 $T = 64;
206 } else {
207 warn "$path: weird filename, skipping.\n";
208 next;
209 }
210
115 # quickly extract width and height of the (necessarily PNG) image 211 # quickly extract width and height of the (necessarily PNG) image
116 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 212 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
117 warn "$path: not a recongized png file, skipping.\n"; 213 warn "$path: not a recognized png file, skipping.\n";
118 next; 214 next;
119 } 215 }
120 216
121 my ($w, $h) = unpack "NN", $1; 217 my ($w, $h) = unpack "NN", $1;
122
123 (my $face = $path) =~ s/^.*\///;
124 my $T = 32;
125
126 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
127 warn "$path: weird filename, skipping.\n";
128 next;
129 }
130 218
131 if ($w < $T || $h < $T) { 219 if ($w < $T || $h < $T) {
132 warn "$path: too small ($w $h), skipping.\n"; 220 warn "$path: too small ($w $h), skipping.\n";
133 next; 221 next;
134 } 222 }
136 if ($w % $T || $h % $T) { 224 if ($w % $T || $h % $T) {
137 warn "$path: weird png size ($w $h), skipping.\n"; 225 warn "$path: weird png size ($w $h), skipping.\n";
138 next; 226 next;
139 } 227 }
140 228
229 (my $base = $stem) =~ s/^.*\///;
230
231 my $fi = $FACEINFO{$base};
232 unless ($fi) {
233 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
234 #next;
235 }
236
237 my $arc = $fi->{arc} || { };
238
239 unless ($path =~ /~$/) {
240 # possibly enlarge
241 if (0 > aio_stat "$stem.64x64.png") {
242 my $other = "$stem.64x64.png~";
243
244 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
245 fork_sub {
246 my $CROP;
247 my $SRC = "png:\Q$path\E";
248
249 my $is_floor = $arc->{is_floor};
250 my $is_wall = 0;
251
252 my ($wall_pfx, $wall_dir, $wall_sfx);
253
254 if (
255 !$is_floor
256 && !$arc->{alive}
257 && $arc->{move_block} eq "all"
258 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
259 ) {
260 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
261
262 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
263 $is_wall = 1;
264 }
265 }
266
267 if ($is_wall || $is_floor) {
268 # add a 4px border and add other images around it
269 $CROP = "-shave 8x8 +repage";
270
271 $w += 8;
272 $h += 8;
273
274 $SRC = "-size ${w}x${h} xc:transparent";
275 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
276
277 # 8 surrounding images
278 for (
279 # x y b r0 r1
280 [-1, -1, 0, 6],
281 [ 0, -1, 1, 10, 14],
282 [+1, -1, 0, 12],
283
284 [-1, 0, 8, 5, 7],
285 #
286 [+1, 0, 2, 5, 13],
287
288 [-1, +1, 0, 3],
289 [ 0, +1, 4, 10, 11],
290 [+1, +1, 0, 9],
291 ) {
292 my ($x, $y, $d, $r0, $r1) = @$_;
293
294 my $tile = $is_floor ? $path
295 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
296 : die;
297
298 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
299 "\Q$tile",
300 $x * ($w - 8) + 4,
301 $y * ($h - 8) + 4;
302 }
303 }
304
305 system "convert -depth 8 $SRC rgba:-"
306 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
307 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
308 and die "convert/cfhq2xa pipeline error: status $? ($!)";
309 system $OPTIPNG, "-i0", "-q", "$other~";
310 die "$other~ has zero size, aborting." unless -s "$other~";
311 rename "$other~", $other;
312 };
313 }
314
315 push @c_png, [$other, !$CACHE];
316 }
317
318 # possibly scale down
319 if (0 > aio_stat "$stem.32x32.png") {
320 my $other = "$stem.32x32.png~";
321
322 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
323 fork_sub {
324 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
325 system $OPTIPNG, "-i0", "-q", "$other~";
326
327 # reduce smoothfaces >10000 bytes
328 # obsolete, no longer required
329 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
330 my $ncolor = 256;
331 while () {
332 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
333 system $OPTIPNG, "-i0", "-q", "$other~~";
334 last if 10000 > -s "$other~~";
335 $ncolor = int $ncolor * 0.9;
336 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
337 }
338
339 printf "reduced %s from %d to %d bytes using %d colours.\n",
340 $other, -s "$other~", -s "$other~~", $ncolor
341 if $VERBOSE >= 2;
342 rename "$other~~", "$other~";
343 }
344
345 die "$other~ has zero size, aborting." unless -s "$other~";
346 rename "$other~", $other;
347 };
348 }
349
350 #warn "scaled down $path to $other\n";#d#
351 push @c_png, [$other, !$CACHE];
352 }
353 }
354
355 (my $face = $stem) =~ s/^.*\///;
356
357 # split all bigfaces, but avoid smoothfaces (*_S)
141 if (($w > $T || $h > $T) && $face !~ /_S\./) { 358 if (($w > $T || $h > $T) && $face !~ /_S\./) {
142 # split 359 # split
143 my @tile; 360 my @tile;
144 for my $x (0 .. (int $w / $T) - 1) { 361 for my $x (0 .. (int $w / $T) - 1) {
145 for my $y (0 .. (int $h / $T) - 1) { 362 for my $y (0 .. (int $h / $T) - 1) {
159 ( 376 (
160 "(", 377 "(",
161 "+clone", 378 "+clone",
162 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 379 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
163 "+repage", 380 "+repage",
381 -quality => "00",
164 -write => "png:$_->[2]~", 382 -write => "png32:$_->[2]~",
165 "+delete", 383 "+delete",
166 ")", 384 ")",
167 ) 385 )
168 } @todo), 386 } @todo),
169 "null:"; 387 "null:";
173 close $convert; 391 close $convert;
174 392
175 # pass 2, optimise, and rename 393 # pass 2, optimise, and rename
176 for (@todo) { 394 for (@todo) {
177 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 395 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
396 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
178 rename "$_->[2]~", $_->[2]; 397 rename "$_->[2]~", $_->[2];
179 } 398 }
180 }; 399 };
181 } 400 }
182 401
186 405
187 if (0 > aio_load $file, $tile) { 406 if (0 > aio_load $file, $tile) {
188 die "$path: unable to read tile +$x+$y, aborting.\n"; 407 die "$path: unable to read tile +$x+$y, aborting.\n";
189 } 408 }
190 IO::AIO::aio_unlink $file unless $CACHE; 409 IO::AIO::aio_unlink $file unless $CACHE;
191 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 410 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
192 } 411 }
193 } else { 412 } else {
194 # use as-is (either small, use smooth) 413 # use as-is (either small, use smooth)
195 commit_png $face, $png; 414 commit_png $stem, $face, $png, $T;
196 } 415 }
416
417 aio_unlink $path if $delete;
197 } 418 }
198 } 419 }
199 420
200 sub process_arc { 421 sub process_arc {
201 while (@arc) { 422 while (my $job = $c_arc->get) {
202 my ($dir, $file) = @{pop @arc}; 423 my ($dir, $file) = @$job;
203 424
204 my $arc; 425 my $arc;
205 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 426 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
206 427
207 my $arc = read_arch "$dir/$file"; 428 my $arc = read_arch "$dir/$file";
208 for my $o (values %$arc) { 429 for my $o (values %$arc) {
209 push @ARC, $o; 430 push @ARC, $o;
431 for (my $m = $o; $m; $m = $m->{more}) {
432 $ARC{$m->{_name}} = $m;
433 }
210 434
211 $o->{editor_folder} = $dir; 435 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
212 436
213 my $visibility = delete $o->{visibility}; 437 my $visibility = delete $o->{visibility};
214 my $magicmap = delete $o->{magicmap}; 438 my $magicmap = delete $o->{magicmap};
439 my $glyph = delete $o->{glyph};
215 440
216 # find upper left corner :/ 441 # find upper left corner :/
217 # omg, this is sooo broken 442 # omg, this is sooo broken
218 my ($dx, $dy); 443 my ($dx, $dy);
219 for (my $o = $o; $o; $o = $o->{more}) { 444 for (my $o = $o; $o; $o = $o->{more}) {
225 my $x = $o->{x} - $dx; 450 my $x = $o->{x} - $dx;
226 my $y = $o->{y} - $dy; 451 my $y = $o->{y} - $dy;
227 452
228 my $ext = $x|$y ? "+$x+$y" : ""; 453 my $ext = $x|$y ? "+$x+$y" : "";
229 454
230 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 455 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
231 456
232 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 457 $visibility = delete $o->{visibility} if exists $o->{visibility};
233 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 458 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
459 $glyph = delete $o->{glyph} if exists $o->{glyph};
234 460
235 my $anim = delete $o->{anim}; 461 my $anim = delete $o->{anim};
236 462
237 if ($anim) { 463 if ($anim) {
464 # possibly add $ext to the animation name to avoid
465 # the need to specify archnames for all parts
466 # of a multipart archetype.
238 $o->{animation} = "$o->{_name}"; 467 $o->{animation} = "$o->{_name}";
468 my $facings = 1;
469 my @frames;
239 470
240 for (@$anim) { 471 for (@$anim) {
241 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 472 if (/^facings\s+(\d+)/) {
473 $facings = $1*1;
474 } elsif (/^blank.x11$|^empty.x11$/) {
475 push @frames, $_;
476 } else {
477 push @frames, "$_$ext";
478 }
242 } 479 }
243 480
244 $ANIM{"$o->{_name}$ext"} = 481 $ANIMINFO{$o->{animation}} = {
245 join "", map "$_\n", 482 facings => $facings,
246 "anim $o->{_name}", 483 frames => \@frames,
247 @$anim,
248 "mina";
249 } 484 };
485 }
250 486
251 for my $face ($o->{face} || (), @{$anim || []}) { 487 for ($o->{face} || (), @{$anim || []}) {
252 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 488 next if /^facings\s/;
253 489
490 my $face = $_;
491 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
492
254 my $info = $FACEINFO{$face} ||= {}; 493 my $info = $FACEINFO{$face} ||= { };
494 $info->{arc} = $o;
495
496 next if $face =~ /^blank.x11$|^empty.x11$/;
255 497
256 $info->{visibility} = $visibility if defined $visibility; 498 $info->{visibility} = $visibility if defined $visibility;
257 $info->{magicmap} = $magicmap if defined $magicmap; 499 $info->{magicmap} = $magicmap if defined $magicmap;
500 $info->{glyph} = $glyph if defined $glyph;
258 } 501 }
259 502
260 if (my $smooth = delete $o->{smoothface}) { 503 if (my $smooth = delete $o->{smoothface}) {
261 my ($face, $smooth) = split /\s+/, $smooth; 504 my %kv = split /\s+/, $smooth;
262 # skip empty_S.x11, it seems to server no purpose whatsoever 505 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
263 # but increases bandwidth demands and worse. 506 while (my ($face, $smooth) = each %kv) {
264 unless ($smooth eq "empty_S.x11") { 507 $FACEINFO{$smooth}{arc} = $o;
508
265 $FACEINFO{$face}{smooth} = $smooth; 509 $FACEINFO{$face}{smooth} = $smooth;
510 $FACEINFO{$face}{smoothlevel} = $level;
266 } 511 }
267 } 512 }
268 } 513 }
269 } 514 }
270 } 515 }
271 } 516 }
272 517
273 sub process_trs { 518 sub process_trs {
274 while (@trs) { 519 while (my $job = $c_trs->get) {
275 my ($dir, $file) = @{pop @trs}; 520 my ($dir, $file) = @$job;
276 my $path = "$dir/$file"; 521 my $path = "$dir/$file";
277 522
278 my $trs; 523 my $trs;
279 if (0 > aio_load $path, $trs) { 524 if (0 > aio_load $path, $trs) {
280 warn "$path: $!, skipping.\n"; 525 warn "$path: $!, skipping.\n";
283 528
284 $TRS .= $trs; 529 $TRS .= $trs;
285 } 530 }
286 } 531 }
287 532
533 my %FILECACHE;
534
535 sub load_cached($;$) {
536 unless (exists $FILECACHE{$_[0]}) {
537 my $data;
538 if (0 < aio_load $_[0], $data) {
539 if ($_[1]) {
540 $data = eval { $_[1]->($data) };
541 warn "$_[0]: $@" if $@;
542 }
543 }
544
545 $FILECACHE{$_[0]} = $data;
546 }
547
548 $FILECACHE{$_[0]}
549 }
550
551 sub process_res {
552 while (my $job = $c_res->get) {
553 my ($dir, $file, $type) = @$job;
554
555 my $data;
556 aio_load "$dir/$file", $data;
557
558 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
559
560 utf8::decode $dir;
561 utf8::decode $file;
562
563 # a meta file for resources is now mandatory
564 unless (exists $meta->{$file}) {
565 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
566 next;
567 }
568
569 $meta = {
570 %{ $meta->{"" } || {} },
571 %{ $meta->{$file} || {} },
572 };
573
574 if ($meta->{license} =~ s/^#//) {
575 $meta->{license} = ({
576 "pd" => "Public Domain",
577 "gpl" => "GNU General Public License, version 3.0 or any later",
578 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
579 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
580 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
581 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
582 })->{$meta->{license}}
583 || warn "$dir/$file: license tag '$meta->{license}' not found.";
584 }
585
586 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
587 ($meta->{author} = $1) =~ s/_/ /g;
588 }
589
590 $file =~ s/\.res$//;
591 $file =~ s/\.(ogg|wav|jpg|png)$//;
592
593 substr $dir, 0, 1 + length $PATH, "";
594
595 if (my $filter = $meta->{cfutil_filter}) {
596 if ($filter eq "yaml2json") {
597 $data = JSON::XS::encode_json YAML::XS::Load $data;
598 } elsif ($filter eq "json2json") {
599 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
600 } elsif ($filter eq "perl2json") {
601 $data = eval $data; die if $@;
602 $data = JSON::XS::encode_json $data;
603 } else {
604 warn "$dir/$file: unknown filter $filter, skipping\n";
605 }
606 }
607
608 $RESOURCE{"$dir/$file"} = {
609 type => (exists $meta->{type} ? delete $meta->{type} : $type),
610 data => $data,
611 %$meta ? (meta => $meta) : (),
612 };
613 }
614 }
615
288 sub find_files; 616 sub find_files;
289 sub find_files { 617 sub find_files {
290 my ($path) = @_; 618 my ($path) = @_;
291 619
292 IO::AIO::aioreq_pri 4; 620 IO::AIO::aioreq_pri 4;
293 IO::AIO::aio_scandir $path, 4, sub { 621 IO::AIO::aio_scandir $path, 4, sub {
294 my ($dirs, $nondirs) = @_; 622 my ($dirs, $nondirs) = @_;
295 623
296 find_files "$path/$_" 624 find_files "$path/$_"
297 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 625 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
626
627 my $dir = $path;
628 substr $dir, 0, 1 + length $PATH, "";
298 629
299 for my $file (@$nondirs) { 630 for my $file (@$nondirs) {
631 if ($dir =~ /^music(?:\/|$)/) {
632 $c_res->put ([$path, $file, 3]) # FT_MUSIC
633 if $file =~ /\.(ogg)$/;
634
635 } elsif ($dir =~ /^sound(?:\/|$)/) {
636 $c_res->put ([$path, $file, 5]) # FT_SOUND
637 if $file =~ /\.(wav|ogg)$/;
638
639 } elsif ($dir =~ /^res(?:\/|$)/) {
640 if ($file =~ /\.(jpg|png)$/) {
641 $c_res->put ([$path, $file, 0]) # FT_FACE
642 } elsif ($file =~ /\.(res)$/) {
643 $c_res->put ([$path, $file, 6]) # FT_RSRC
644 } else {
645 $c_res->put ([$path, $file, undef]);
646 }
647
300 if ($file =~ /\.png$/) { 648 } elsif ($file =~ /\.png$/) {
301 push @png, "$path/$file"; 649 push @c_png, ["$path/$file", 0];
650
302 } elsif ($file =~ /\.trs$/) { 651 } elsif ($file =~ /\.trs$/) {
303 push @trs, [$path, $file]; 652 $c_trs->put ([$path, $file]);
653
304 } elsif ($file =~ /\.arc$/) { 654 } elsif ($file =~ /\.arc$/) {
305 push @arc, [$path, $file]; 655 $c_arc->put ([$path, $file]);
656
306 } else { 657 } else {
307 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 658 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
308 } 659 }
309 } 660 }
310 }; 661 };
662 }
663
664 sub generate_plurals {
665# use Lingua::EN::Inflect ();
666# Lingua::EN::Inflect::classical;
667# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
668# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
669#
670# for my $a (@ARC) {
671# my $name = $a->{name} || $a->{_name};
672#
673# next unless $a->{name_pl};
674# next if $a->{invisible};
675# next if $a->{is_floor};
676# next if $a->{no_pick};
677#
678# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
679# my $pl = $test =~ /^(?:eq|p:.)$/
680# ? $name
681# : Lingua::EN::Inflect::PL $name;
682#
683# if ($pl ne $a->{name_pl}) {
684# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
685# }
686# }
311 } 687 }
312 688
313 sub inst_arch($) { 689 sub inst_arch($) {
314 my (undef, $path) = @_; 690 my (undef, $path) = @_;
315 691
692 $PATH = $path;
693
694 print "\n",
316 print "installing '$path' to '$DATADIR'\n"; 695 "Installing '$path' to '$DATADIR'\n",
696 "\n",
697 "This can take a long time if you run this\n",
698 "for the first time or do not use --cache.\n",
699 "\n",
700 "Unless you run verbosely, all following warning\n",
701 "or error messages indicate serious problems.\n",
702 "\n";
317 703
318 if (!-d "$path/treasures") { 704 if (!-d "$path/treasures") {
319 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 705 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
320 exit 1 unless $FORCE; 706 exit 1 unless $FORCE;
321 } 707 }
322 708
709 print "scanning files...\n" if $VERBOSE;
710
323 find_files $path; 711 find_files $path;
712
713 my @a_arc = map +(async \&process_arc), 1..2;
714 my @a_res = map +(async \&process_res), 1..2;
715 my @a_trs = map +(async \&process_trs), 1..2;
716
324 IO::AIO::flush; 717 IO::AIO::flush;
325 718
326 $_->join for ( 719 $c_res->shutdown;
327 (async \&process_png), (async \&process_png), 720 $c_arc->shutdown;
328 (async \&process_trs), (async \&process_trs), 721 $c_trs->shutdown;
329 (async \&process_arc), (async \&process_arc),
330 );
331 722
723 print "start file scan, arc, res processing...\n" if $VERBOSE;
724
725 $_->join for @a_arc; # need to parse all archetypes before png processing
726
727 print "end arc, start png processing...\n" if $VERBOSE;
728
729 # eight png crunchers work fine for my 4x smp machine
730 my @a_png = map +(async \&process_png), 1..8;
731
732 $_->join for (@a_trs, @a_res, @a_png);
733
734 print "scanning done, processing results...\n" if $VERBOSE;
332 { 735 {
333 open my $fh, ">:utf8", "$DATADIR/animations~" 736 # remove path prefix from editor_folder
334 or die "$DATADIR/animations~: $!"; 737 $_->{editor_folder} =~ /^\x00/
335 print $fh join "", map $ANIM{$_}, sort keys %ANIM 738 and substr $_->{editor_folder}, 0, 2 + length $path, ""
739 for values %ARC;
740
741 print "resolving inheritance tree...\n" if $VERBOSE;
742 # resolve inherit
743 while () {
744 my $progress;
745 my $loop;
746
747 for my $o (values %ARC) {
748 for my $other (split /,/, $o->{inherit}) {
749 if (my $s = $ARC{$other}) {
750 if ($s->{inherit}) {
751 $loop = $s;
752 } else {
753 delete $o->{inherit};
754 my %s = %$s;
755 delete @s{qw(_name more name name_pl)};
756 %$o = ( %s, %$o );
757 ++$progress;
758 }
759 } else {
760 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
761 delete $ARC{$o->{_name}};
762 }
763 }
764 }
765
766 unless ($progress) {
767 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
768 if $loop;
769
770 last;
771 }
336 } 772 }
337 773
338 { 774 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
775 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
776
777 print "generating plurals...\n" if $VERBOSE;
778 generate_plurals;
779
780 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
339 open my $fh, ">:utf8", "$DATADIR/archetypes~" 781 open my $fh, ">:utf8", "$DATADIR/archetypes~"
340 or die "$DATADIR/archetypes~: $!"; 782 or die "$DATADIR/archetypes~: $!";
341 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 783 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
342 print $fh Crossfire::archlist_to_string \@ARC;
343 } 784 }
344 785
345 { 786 {
787 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
346 open my $fh, ">:utf8", "$DATADIR/treasures~" 788 open my $fh, ">:utf8", "$DATADIR/treasures~"
347 or die "$DATADIR/treasures~: $!"; 789 or die "$DATADIR/treasures~: $!";
348 print $fh $TRS; 790 print $fh $TRS;
349 } 791 }
350 792
351 { 793 {
352 while (my ($k, $v) = each %FACEINFO) { 794 print "processing facedata...\n" if $VERBOSE;
353 $v->{data32} ||= delete $PNG32{$k};
354 }
355
356 while (my ($k, $v) = each %FACEINFO) { 795 while (my ($k, $v) = each %FACEINFO) {
357 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 796 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
797 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
358 798
359 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 799 make_hash $k, $v->{data32}, $v->{hash32};
800 make_hash $k, $v->{data64}, $v->{hash64};
801
802 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
803 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
804
805 my $stem = delete $v->{stem};
806 $v->{glyph} //= substr $stem, 0, 1;
807
808 if (my $magicmap = $v->{magicmap}) {
809 $magicmap =~ y/A-Z_\-/a-z/d;
810 $v->{magicmap} = $COLOR{$magicmap};
360 } 811 }
361 812
813 delete $v->{arc};
814 }
815
816 print "processing resources...\n" if $VERBOSE;
817 my $enc = JSON::XS->new->utf8->canonical->relaxed;
818 while (my ($k, $v) = each %RESOURCE) {
819
820 if ($v->{meta} && $v->{meta}{datadir}) {
821 delete $RESOURCE{$k};
822
823 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
824
825 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
826 open my $fh, ">:raw", "$DATADIR/$k~"
827 or die "$DATADIR/$k~: $!";
828 syswrite $fh, $v->{data};
829 push @COMMIT, $k;
830
831 } else {
832 if ($v->{type} & 1) {
833 # prepend meta info
834
835 my $meta = $enc->encode ({
836 name => $k,
837 %{ $v->{meta} || {} },
838 });
839
840 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
841 }
842
843 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
844 }
845 }
846
847 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
848 scalar keys %FACEINFO,
849 scalar keys %ANIMINFO,
850 scalar keys %RESOURCE
851 if $VERBOSE;
852
362 open my $fh, ">:perlio", "$DATADIR/faces~" 853 open my $fh, ">:perlio", "$DATADIR/facedata~"
363 or die "$DATADIR/faces~: $!"; 854 or die "$DATADIR/facedata~: $!";
364 855
365 print $fh Storable::nfreeze \%FACEINFO; 856 print $fh nfreeze {
857 version => 2,
858 faceinfo => \%FACEINFO,
859 animinfo => \%ANIMINFO,
860 resource => \%RESOURCE,
366 } 861 };
367 862
863 }
864
865 print "committing files...\n" if $VERBOSE;
866
368 for (qw(archetypes faces animations treasures)) { 867 for (qw(archetypes facedata treasures), @COMMIT) {
369 chmod 0644, "$DATADIR/$_~"; 868 chmod 0644, "$DATADIR/$_~";
370 rename "$DATADIR/$_~", "$DATADIR/$_" 869 rename "$DATADIR/$_~", "$DATADIR/$_"
371 or die "$DATADIR/$_: $!"; 870 or die "$DATADIR/$_: $!";
372 } 871 }
373 872

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines